searchNodes=[{"ref":"FileSystem.html","title":"FileSystem","type":"module","doc":"FileSystem A file change watcher wrapper based on fs System Support Mac fsevent Linux, FreeBSD and OpenBSD inotify Windows inotify-win NOTE: On Linux, FreeBSD and OpenBSD you need to install inotify-tools. On Macos 10.14, you need run `open /Library/Developer/CommandLineTools/Packages/macOS_SDK_headers_for_macOS_10.14.pkg` to compile `mac_listener`. Usage Put file_system in the deps and application part of your mix.exs defmodule Excellent.Mixfile do use Mix.Project def project do ... end defp deps do [ { :file_system, &quot;~&gt; 0.2&quot;, only: :test }, ] end ... end Subscription API You can spawn a worker and subscribe to events from it: {:ok, pid} = FileSystem.start_link(dirs: [&quot;/path/to/some/files&quot;]) FileSystem.subscribe(pid) or {:ok, pid} = FileSystem.start_link(dirs: [&quot;/path/to/some/files&quot;], name: :my_monitor_name) FileSystem.subscribe(:my_monitor_name) The pid you subscribed from will now receive messages like {:file_event, worker_pid, {file_path, events}} and {:file_event, worker_pid, :stop} Example with GenServer defmodule Watcher do use GenServer def start_link(args) do GenServer.start_link(__MODULE__, args) end def init(args) do {:ok, watcher_pid} = FileSystem.start_link(args) FileSystem.subscribe(watcher_pid) {:ok, %{watcher_pid: watcher_pid}} end def handle_info({:file_event, watcher_pid, {path, events}}, %{watcher_pid: watcher_pid}=state) do # YOUR OWN LOGIC FOR PATH AND EVENTS {:noreply, state} end def handle_info({:file_event, watcher_pid, :stop}, %{watcher_pid: watcher_pid}=state) do # YOUR OWN LOGIC WHEN MONITOR STOP {:noreply, state} end end Tweaking behaviour via extra arguments For each platform, you can pass extra arguments to the underlying listener process. Each backend support different extra arguments, check backend module documentation for more information. Here is an example to get instant notifications on file changes for Mac OS X: FileSystem.start_link(dirs: [&quot;/path/to/some/files&quot;], latency: 0, watch_root: true)"},{"ref":"FileSystem.html#start_link/1","title":"FileSystem.start_link/1","type":"function","doc":"Options :dirs ([string], required), the dir list to monitor :backend (atom, optional), default backends: :fs_mac for macos, :fs_inotify for linux, freebsd and openbsd, :fs_windows for windows :name (atom, optional), name can be used to subscribe as the same as pid when the name is given. The name should be the name of worker process. All rest options will treated as backend options. See backend module documents for more details. Example Simple usage: iex&gt; {:ok, pid} = FileSystem.start_link(dirs: [&quot;/tmp/fs&quot;]) iex&gt; FileSystem.subscribe(pid) Get instant notifications on file changes for Mac OS X: iex&gt; FileSystem.start_link(dirs: [&quot;/path/to/some/files&quot;], latency: 0) Named monitor with specified backend: iex&gt; FileSystem.start_link(backend: :fs_mac, dirs: [&quot;/tmp/fs&quot;], name: :worker) iex&gt; FileSystem.subscribe(:worker)"},{"ref":"FileSystem.html#subscribe/1","title":"FileSystem.subscribe/1","type":"function","doc":"Register the current process as a subscriber of a file_system worker. The pid you subscribed from will now receive messages like {:file_event, worker_pid, {file_path, events}} {:file_event, worker_pid, :stop}"},{"ref":"FileSystem.Backend.html","title":"FileSystem.Backend","type":"behaviour","doc":"FileSystem Backend Behaviour."},{"ref":"FileSystem.Backend.html#backend/1","title":"FileSystem.Backend.backend/1","type":"function","doc":"Get and validate backend module, return {:ok, backend_module} when success and return {:error, reason} when fail. When nil is given, will return default backend by os. When a custom module is given, make sure start_link/1, bootstrap/0 and supported_system/0 are defnied."},{"ref":"FileSystem.Backend.html#c:bootstrap/0","title":"FileSystem.Backend.bootstrap/0","type":"callback","doc":""},{"ref":"FileSystem.Backend.html#c:known_events/0","title":"FileSystem.Backend.known_events/0","type":"callback","doc":""},{"ref":"FileSystem.Backend.html#c:supported_systems/0","title":"FileSystem.Backend.supported_systems/0","type":"callback","doc":""},{"ref":"FileSystem.Backends.FSInotify.html","title":"FileSystem.Backends.FSInotify","type":"module","doc":"This file is a fork from https://github.com/synrc/fs. FileSysetm backend for linux, freebsd and openbsd, a GenServer receive data from Port, parse event and send it to the worker process. Need inotify-tools installed to use this backend. Backend Options :recursive (bool, default: true), monitor directories and their contents recursively Executable File Path The default behaivour to find executable file is finding inotifywait from $PATH, there&#39;re two ways to custom it, useful when run :file_system with escript. config with config.exs config :file_system, :fs_inotify, executable_file: &quot;YOUR_EXECUTABLE_FILE_PATH&quot; config with FILESYSTEM_FSINOTIFY_EXECUTABLE_FILE os environment FILESYSTEM_FSINOTIFY_EXECUTABLE_FILE=YOUR_EXECUTABLE_FILE_PATH"},{"ref":"FileSystem.Backends.FSInotify.html#bootstrap/0","title":"FileSystem.Backends.FSInotify.bootstrap/0","type":"function","doc":"Callback implementation for FileSystem.Backend.bootstrap/0."},{"ref":"FileSystem.Backends.FSInotify.html#child_spec/1","title":"FileSystem.Backends.FSInotify.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"FileSystem.Backends.FSInotify.html#init/1","title":"FileSystem.Backends.FSInotify.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"FileSystem.Backends.FSInotify.html#known_events/0","title":"FileSystem.Backends.FSInotify.known_events/0","type":"function","doc":"Callback implementation for FileSystem.Backend.known_events/0."},{"ref":"FileSystem.Backends.FSInotify.html#parse_line/1","title":"FileSystem.Backends.FSInotify.parse_line/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSInotify.html#parse_options/1","title":"FileSystem.Backends.FSInotify.parse_options/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSInotify.html#start_link/1","title":"FileSystem.Backends.FSInotify.start_link/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSInotify.html#supported_systems/0","title":"FileSystem.Backends.FSInotify.supported_systems/0","type":"function","doc":"Callback implementation for FileSystem.Backend.supported_systems/0."},{"ref":"FileSystem.Backends.FSMac.html","title":"FileSystem.Backends.FSMac","type":"module","doc":"This file is a fork from https://github.com/synrc/fs. FileSysetm backend for macos, a GenServer receive data from Port, parse event and send it to the worker process. Will compile executable the buildin executable file when file the first time it is used. Backend Options :latency (float, default: 0.5), latency period. :no_defer (bool, default: false), enable no-defer latency modifier. Works with latency parameter, Also check apple FSEvent api documents https://developer.apple.com/documentation/coreservices/kfseventstreamcreateflagnodefer :watch_root (bool, default: false), watch for when the root path has changed. Set the flag true to monitor events when watching /tmp/fs/dir and run mv /tmp/fs /tmp/fx. Also check apple FSEvent api documents https://developer.apple.com/documentation/coreservices/kfseventstreamcreateflagwatchroot recursive is enabled by default, no option to disable it for now. Executable File Path The default executable file is mac_listener in priv dir of :file_system application, there&#39;re two ways to custom it, useful when run :file_system with escript. config with config.exs config :file_system, :fs_mac, executable_file: &quot;YOUR_EXECUTABLE_FILE_PATH&quot; config with FILESYSTEM_FSMAC_EXECUTABLE_FILE os environment FILESYSTEM_FSMAC_EXECUTABLE_FILE=YOUR_EXECUTABLE_FILE_PATH"},{"ref":"FileSystem.Backends.FSMac.html#bootstrap/0","title":"FileSystem.Backends.FSMac.bootstrap/0","type":"function","doc":"Callback implementation for FileSystem.Backend.bootstrap/0."},{"ref":"FileSystem.Backends.FSMac.html#child_spec/1","title":"FileSystem.Backends.FSMac.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"FileSystem.Backends.FSMac.html#init/1","title":"FileSystem.Backends.FSMac.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"FileSystem.Backends.FSMac.html#known_events/0","title":"FileSystem.Backends.FSMac.known_events/0","type":"function","doc":"Callback implementation for FileSystem.Backend.known_events/0."},{"ref":"FileSystem.Backends.FSMac.html#parse_line/1","title":"FileSystem.Backends.FSMac.parse_line/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSMac.html#parse_options/1","title":"FileSystem.Backends.FSMac.parse_options/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSMac.html#start_link/1","title":"FileSystem.Backends.FSMac.start_link/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSMac.html#supported_systems/0","title":"FileSystem.Backends.FSMac.supported_systems/0","type":"function","doc":"Callback implementation for FileSystem.Backend.supported_systems/0."},{"ref":"FileSystem.Backends.FSPoll.html","title":"FileSystem.Backends.FSPoll","type":"module","doc":"FileSysetm backend for any OS, a GenServer that regularly scans file system to detect changes and send them to the worker process. Backend Options :interval (integer, default: 1000), polling interval Use FSPoll Backend Unlike other backends, polling backend is never automatically chosen in any OS environment, despite being usable on all platforms. To use polling backend, one has to explicitly specify in the backend option."},{"ref":"FileSystem.Backends.FSPoll.html#bootstrap/0","title":"FileSystem.Backends.FSPoll.bootstrap/0","type":"function","doc":"Callback implementation for FileSystem.Backend.bootstrap/0."},{"ref":"FileSystem.Backends.FSPoll.html#child_spec/1","title":"FileSystem.Backends.FSPoll.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"FileSystem.Backends.FSPoll.html#init/1","title":"FileSystem.Backends.FSPoll.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"FileSystem.Backends.FSPoll.html#known_events/0","title":"FileSystem.Backends.FSPoll.known_events/0","type":"function","doc":"Callback implementation for FileSystem.Backend.known_events/0."},{"ref":"FileSystem.Backends.FSPoll.html#start_link/1","title":"FileSystem.Backends.FSPoll.start_link/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSPoll.html#supported_systems/0","title":"FileSystem.Backends.FSPoll.supported_systems/0","type":"function","doc":"Callback implementation for FileSystem.Backend.supported_systems/0."},{"ref":"FileSystem.Backends.FSWindows.html","title":"FileSystem.Backends.FSWindows","type":"module","doc":"This file is a fork from https://github.com/synrc/fs. FileSysetm backend for windows, a GenServer receive data from Port, parse event and send it to the worker process. Need binary executable file packaged in to use this backend. Backend Options :recursive (bool, default: true), monitor directories and their contents recursively Executable File Path The default executable file is inotifywait.exe in priv dir of :file_system application, there&#39;re two ways to custom it, useful when run :file_system with escript. config with config.exs config :file_system, :fs_windows, executable_file: &quot;YOUR_EXECUTABLE_FILE_PATH&quot; config with FILESYSTEM_FSWINDOWS_EXECUTABLE_FILE os environment FILESYSTEM_FSWINDOWS_EXECUTABLE_FILE=YOUR_EXECUTABLE_FILE_PATH"},{"ref":"FileSystem.Backends.FSWindows.html#bootstrap/0","title":"FileSystem.Backends.FSWindows.bootstrap/0","type":"function","doc":"Callback implementation for FileSystem.Backend.bootstrap/0."},{"ref":"FileSystem.Backends.FSWindows.html#child_spec/1","title":"FileSystem.Backends.FSWindows.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"FileSystem.Backends.FSWindows.html#init/1","title":"FileSystem.Backends.FSWindows.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"FileSystem.Backends.FSWindows.html#known_events/0","title":"FileSystem.Backends.FSWindows.known_events/0","type":"function","doc":"Callback implementation for FileSystem.Backend.known_events/0."},{"ref":"FileSystem.Backends.FSWindows.html#parse_line/1","title":"FileSystem.Backends.FSWindows.parse_line/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSWindows.html#parse_options/1","title":"FileSystem.Backends.FSWindows.parse_options/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSWindows.html#start_link/1","title":"FileSystem.Backends.FSWindows.start_link/1","type":"function","doc":""},{"ref":"FileSystem.Backends.FSWindows.html#supported_systems/0","title":"FileSystem.Backends.FSWindows.supported_systems/0","type":"function","doc":"Callback implementation for FileSystem.Backend.supported_systems/0."},{"ref":"FileSystem.Worker.html","title":"FileSystem.Worker","type":"module","doc":"FileSystem Worker Process with the backend GenServer, receive events from Port Process and forward it to subscribers."},{"ref":"FileSystem.Worker.html#child_spec/1","title":"FileSystem.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"readme.html","title":"FileSystem","type":"extras","doc":"FileSystem A file change watcher wrapper based on fs"},{"ref":"readme.html#system-support","title":"FileSystem - System Support","type":"extras","doc":"Mac fsevent Linux, FreeBSD and OpenBSD inotify Windows inotify-win NOTE: On Linux, FreeBSD and OpenBSD you need to install inotify-tools. On Macos 10.14, you need run `open /Library/Developer/CommandLineTools/Packages/macOS_SDK_headers_for_macOS_10.14.pkg` to compile `mac_listener`."},{"ref":"readme.html#usage","title":"FileSystem - Usage","type":"extras","doc":"Put file_system in the deps and application part of your mix.exs defmodule Excellent.Mixfile do use Mix.Project def project do ... end defp deps do [ { :file_system, &quot;~&gt; 0.2&quot;, only: :test }, ] end ... end Subscription API You can spawn a worker and subscribe to events from it: {:ok, pid} = FileSystem.start_link(dirs: [&quot;/path/to/some/files&quot;]) FileSystem.subscribe(pid) or {:ok, pid} = FileSystem.start_link(dirs: [&quot;/path/to/some/files&quot;], name: :my_monitor_name) FileSystem.subscribe(:my_monitor_name) The pid you subscribed from will now receive messages like {:file_event, worker_pid, {file_path, events}} and {:file_event, worker_pid, :stop} Example with GenServer defmodule Watcher do use GenServer def start_link(args) do GenServer.start_link(__MODULE__, args) end def init(args) do {:ok, watcher_pid} = FileSystem.start_link(args) FileSystem.subscribe(watcher_pid) {:ok, %{watcher_pid: watcher_pid}} end def handle_info({:file_event, watcher_pid, {path, events}}, %{watcher_pid: watcher_pid}=state) do # YOUR OWN LOGIC FOR PATH AND EVENTS {:noreply, state} end def handle_info({:file_event, watcher_pid, :stop}, %{watcher_pid: watcher_pid}=state) do # YOUR OWN LOGIC WHEN MONITOR STOP {:noreply, state} end end"},{"ref":"readme.html#tweaking-behaviour-via-extra-arguments","title":"FileSystem - Tweaking behaviour via extra arguments","type":"extras","doc":"For each platform, you can pass extra arguments to the underlying listener process. Each backend support different extra arguments, check backend module documentation for more information. Here is an example to get instant notifications on file changes for Mac OS X: FileSystem.start_link(dirs: [&quot;/path/to/some/files&quot;], latency: 0, watch_root: true)"}]